package awais.instagrabber.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;

import com.thoughtbot.expandablerecyclerview.ExpandableRecyclerViewAdapter;
import com.thoughtbot.expandablerecyclerview.models.ExpandableGroup;

import java.util.List;

import awais.instagrabber.R;
import awais.instagrabber.adapters.viewholder.FollowsViewHolder;
import awais.instagrabber.adapters.viewholder.GroupHeaderHolder;
import awais.instagrabber.models.FollowModel;
import awais.instagrabber.utils.Utils;

public class FollowCompareAdapter extends ExpandableRecyclerViewAdapter<GroupHeaderHolder, FollowsViewHolder> {
    private final View.OnClickListener onClickListener;
    private final LayoutInflater layoutInflater;

    public FollowCompareAdapter(final Context context, final View.OnClickListener onClickListener, final List<? extends ExpandableGroup> groups) {
        super(groups);
        this.onClickListener = onClickListener;
        this.layoutInflater = LayoutInflater.from(context);
    }

    @Override
    public GroupHeaderHolder onCreateGroupViewHolder(final ViewGroup parent, final int viewType) {
        return new GroupHeaderHolder(layoutInflater.inflate(android.R.layout.simple_list_item_1, parent, false));
    }

    @Override
    public FollowsViewHolder onCreateChildViewHolder(final ViewGroup parent, final int viewType) {
        return new FollowsViewHolder(layoutInflater.inflate(R.layout.follow_item, parent, false));
    }

    @Override
    public void onBindGroupViewHolder(@NonNull final GroupHeaderHolder holder, final int flatPosition, final ExpandableGroup group) {
        holder.setTitle(group);
    }

    @Override
    public void onBindChildViewHolder(final FollowsViewHolder holder, final int flatPosition, @NonNull final ExpandableGroup group, final int childIndex) {
        final Object o = group.getItems().get(childIndex);

        if (o instanceof FollowModel) {
            final FollowModel model = (FollowModel) o;

            holder.itemView.setTag(model);
            holder.itemView.setOnClickListener(onClickListener);

            holder.tvUsername.setText(model.getUsername());
            holder.tvFullName.setText(model.getFullName());

            Utils.PICASSO.load(model.getProfilePicUrl()).into(holder.profileImage);
        }
    }
}