package awais.instagrabber.models;

import awais.instagrabber.asyncs.SuggestionsAsync;

public final class SuggestionModel {
    private final boolean isPrivate, isVerified;
    private final String id;
    private final String username;
    private final String name;
    private final String profilePic;
    private final SuggestionsAsync.SuggestionType suggestionType;

    public SuggestionModel(final boolean isPrivate, final boolean isVerified, final String id, final String username,
                           final String name, final String profilePic, final SuggestionsAsync.SuggestionType suggestionType) {
        this.isPrivate = isPrivate;
        this.isVerified = isVerified;
        this.id = id;
        this.username = username;
        this.name = name;
        this.profilePic = profilePic;
        this.suggestionType = suggestionType;
    }

    public boolean isPrivate() {
        return isPrivate;
    }

    public boolean isVerified() {
        return isVerified;
    }

    public String getId() {
        return id;
    }

    public String getUsername() {
        return username;
    }

    public String getName() {
        return name;
    }

    public String getProfilePic() {
        return profilePic;
    }

    public SuggestionsAsync.SuggestionType getSuggestionType() {
        return suggestionType;
    }
}
